module alu(reset, tclk, ir, select, acc, latch, c, z, d_bus);
input	reset, tclk;
input [7:0]	select,ir;
output	[7:0] acc, latch;
reg [7:0]	acc, latch;
output	z,c;
reg	c,z;
inout [7:0]	d_bus;

always	@(posedge tclk or posedge reset) begin
	if (reset) begin acc<=8'b0; latch<=8'b0; c<=1'b0; z<=1'b0; end
	else begin
		if(select[5]) begin
			casex(ir[7:5])
				3'b000: begin {c,latch}<=acc + d_bus;    z<=((acc + d_bus)==8'b0); end
				3'b001: begin {c,latch}<=acc - d_bus;    z<=((acc - d_bus)==8'b0); end
				3'b010: begin {c,latch}<=~(acc & d_bus); z<=((~(acc & d_bus))==8'b0); end
				3'b011: begin {c,latch}<=acc << 1;       z<=((acc <<1 )==8'b0); end
				3'b101: latch<=acc;
			endcase
		end
		if(select[6]) acc<=d_bus;
	end
end
assign d_bus= (select[1])? latch: 8'bz;

endmodule