module mem(tclk, a_bus, inp, oup, select, d_bus);
input tclk;
input [4:0] a_bus;
input [7:0] inp;
input [7:0] select;
output [7:0] oup;
inout [7:0] d_bus;
reg [7:0] mem[0:31];
reg [7:0] oup;

function [7:0] memout;  // memory read
input [4:0] a_bus;
	case(a_bus) 
		0:memout =8'h9e;
		1:memout =8'hbf;
		2:memout =8'h44;
		3:memout =8'he0;
		4:memout =8'h00;
		30:memout =inp;
		default: memout =mem[a_bus];
	endcase
endfunction 

always @(posedge tclk) begin
	if(select[2])
		if (a_bus==31) oup<=d_bus; else mem[a_bus] <=d_bus;
end
assign d_bus = (~select[1])? memout(a_bus): 8'bz;

endmodule
