module pcir(reset, tclk, halt, pc, ir, a_bus, d_bus, select);
input reset, tclk;
input [7:0] d_bus, select;
output halt;
output [4:0] a_bus;
output [4:0] pc;
output [7:0] ir;
reg [4:0] pc;
reg [7:0] ir;

always @(posedge tclk or posedge reset) begin
	if (reset) begin pc<=5'b0; ir<=8'b0; end 
	else begin
		if(select[7]) pc<=ir[4:0];
		else if(select[4]) pc<=pc+5'b1;
		else if(select[3]) ir<=d_bus;
	end
end
assign a_bus = (select[0])? pc: ir[4:0];
assign halt = (ir==8'hff);

endmodule