module pcirtest(reset, osc, halt, pc, ir, a_bus, d_bus, select);
input reset, osc;
input [7:0] d_bus, select;
output halt;
output [4:0] a_bus;
output [4:0] pc;
output [7:0] ir;
reg [4:0] pc;
reg [7:0] ir;
reg [2:0] count;

always @(posedge osc) begin
	count <= count + 3'b001;
end

pcir pcir(reset, count[2], halt, pc, ir, a_bus, d_bus, select);

alutest(osc, ir_in, acc_wr, acc, latch, c, z, mem_out, keygl);
input	osc, acc_wr;
input [7:0] mem_out;
input [2:0] ir_in;
output [7:0] acc, latch;
output	c,z, keygl;
wire [7:0] ir, select;
wire reset;

assign ir[7:5] = ir_in[2:0];
assign ir[4:0] = 5'b00000;
assign keygl = 1'b0;
assign reset = 1'b0;
assign select[7:0] = (acc_wr)? 8'b01000000: 8'b00100000;

alu alu(reset, osc, ir, select, acc, latch, c, z, mem_out);

endmodule

module pcir(reset, tclk, halt, pc, ir, a_bus, d_bus, select);
input reset, tclk;
input [7:0] d_bus, select;
output halt;
output [4:0] a_bus;
output [4:0] pc;
output [7:0] ir;
reg [4:0] pc;
reg [7:0] ir;

always @(posedge tclk) begin
	if (reset) begin pc<=5'b0; ir<=8'b0; end 
	else begin
		if(select[7]) pc<=ir[4:0];
		else if(select[4]) pc<=pc+5'b1;
		else if(select[3]) ir<=d_bus;

	end
end
assign a_bus=(select[0]) ? pc: ir[4:0];
assign halt=(ir==8'hff);
endmodule


ule clocktest(reset, osc, tclk, sclk );
input	reset, osc;
output	tclk, sclk;
reg [2:0]	count;

clock clock(reset, count[2], tclk, sclk );
always @(posedge osc) begin
	count <= count + 3'b001;
end

endmodule